--
-- Panteleev Sergey
-- Script allows to cut / copy / paste selected materials between sme tabs
-- fatbbc @ gmail.com 
--

try (destroydialog jah_SMEcutcopypaste ) catch ()
 rollout jah_SMEcutcopypaste "SME cut/copy/paste" width:200 (
	 
	button cut "cut" across:3 width:60 offset:[-4,0]
	 button copy_ "copy" width:60 align:#center
	button paste "paste" width:60 offset:[4,0]
	 
	local mtls = undefined
	 
	fn getSMEselectedMtls = (
	
		viewNode = sme.GetView (sme.activeView)
		smeSelMats = #()
		for n = 1 to trackViewNodes[#sme][(sme.activeView)].numSubs do (
		m = trackViewNodes[#sme][sme.activeView][n].reference
		b = viewNode.GetNodeByRef m
		if b.selected and superclassof m == material do append smeSelMats m		
		)
		smeSelMats
	
	)

	fn pasteSMEmtls mtls = (
		
		for mtl in mtls do (
			
			(sme.GetView (sme.activeView)).createnode mtl [0,0]
			
		)
	)

	fn copySMEmtls = (
		
		local mtls = for m in getSMEselectedMtls() collect (copy m)	 
		mtls
			
	)

	fn cutSMEmtls = (
		
		local mtls = getSMEselectedMtls()
		 (sme.GetView (sme.activeView)).deleteselection()
		mtls
			 
	)
	 
	on cut pressed do (
		
		mtls = cutSMEmtls()		
		
	)
	
	on copy_ pressed do (
		
		mtls = copySMEmtls()
		
	)
	
	on paste pressed do (
				
		if mtls.count > 0 do pasteSMEmtls mtls
		
	)
	 
)
 createDialog jah_SMEcutcopypaste pos:[100,100]
